import { IgrLegendBase, IIgrLegendBaseProps } from "./igr-legend-base";
import { ItemLegend } from "./ItemLegend";
/**
 * Represents a legend that displays an item for each point in the series.
*
* You can use the `IgxItemLegendComponent` to display a legend item for each data member bound to the `IgxItemLegendComponent`
*/
export declare class IgrItemLegend extends IgrLegendBase<IIgrItemLegendProps> {
    protected createImplementation(): ItemLegend;
    readonly i: ItemLegend;
    constructor(props: IIgrItemLegendProps);
    /**
     * Gets whether or not this legend supports itemwise visuals
    */
    readonly isItemwise: boolean;
}
export interface IIgrItemLegendProps extends IIgrLegendBaseProps {
}
