import { IgrLegendBase } from "./igr-legend-base";
import { ItemLegend } from "./ItemLegend";
/**
 * Represents a legend that displays an item for each point in the series.
*
* You can use the `IgxItemLegendComponent` to display a legend item for each data member bound to the `IgxItemLegendComponent`
*/
export class IgrItemLegend extends IgrLegendBase {
    createImplementation() {
        return new ItemLegend();
    }
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether or not this legend supports itemwise visuals
    */
    get isItemwise() {
        return this.i.isItemwise;
    }
}
