import { IgrStrategyBasedIndicator, IIgrStrategyBasedIndicatorProps } from "./igr-strategy-based-indicator";
import { PositiveVolumeIndexIndicator } from "./PositiveVolumeIndexIndicator";
/**
 * Represents a IgxDataChartComponent Positive Volume Index (PVI) indicator series.
 * Default required members: Close, Volume
*
* You can use the `IgxPositiveVolumeIndexIndicatorComponent` with the 'NegativeVolumeIndexIndicator' to identify bull markets.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-positive-volume-index-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-positive-volume-index-indicator>
* </igx-data-chart>
* ```
*/
export declare class IgrPositiveVolumeIndexIndicator extends IgrStrategyBasedIndicator<IIgrPositiveVolumeIndexIndicatorProps> {
    protected createImplementation(): PositiveVolumeIndexIndicator;
    readonly i: PositiveVolumeIndexIndicator;
    constructor(props: IIgrPositiveVolumeIndexIndicatorProps);
}
export interface IIgrPositiveVolumeIndexIndicatorProps extends IIgrStrategyBasedIndicatorProps {
}
