import { Ring } from "./igr-ring";
import { IgrRingSeriesBase } from "./igr-ring-series-base";
import { RingSeries } from "./RingSeries";
/**
 * Represents one ring in IgxDoughnutChartComponent series.
*/
export class IgrRingSeries extends IgrRingSeriesBase {
    createImplementation() {
        return new RingSeries();
    }
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets reference to the ring data.
    */
    get ring() {
        if (this.i.dr == null) {
            return null;
        }
        if (!this.i.dr.externalObject) {
            let e = new Ring();
            e._implementation = this.i.dr;
            this.i.dr.externalObject = e;
        }
        return this.i.dr.externalObject;
    }
    set ring(v) {
        v == null ? this.i.dr = null : this.i.dr = v.i;
    }
}
