import * as tslib_1 from "tslib";
import * as React from 'react';
import { delegateCombine, delegateRemove } from "igniteui-react-core/ES5/type";
import { SliceClickEventArgs } from "./igr-slice-click-event-args";
import { HoleDimensionsChangedEventArgs } from "./igr-hole-dimensions-changed-event-args";
import { XamDoughnutChart } from "./XamDoughnutChart";
import { getModifiedProps, isValidProp, ensureBool, fromPoint } from "igniteui-react-core/ES5/componentUtil";
import { Style } from "igniteui-react-core/ES5/Style";
/**
 * Represents concentric circles divided on arcs  depending on data.
*/
var IgrDoughnutChart = /** @class */ (function (_super) {
    tslib_1.__extends(IgrDoughnutChart, _super);
    function IgrDoughnutChart(props) {
        var _this = _super.call(this, props) || this;
        _this._sliceClick = null;
        _this._sliceClick_wrapped = null;
        _this._holeDimensionsChanged = null;
        _this._holeDimensionsChanged_wrapped = null;
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrDoughnutChart.prototype.createImplementation = function () {
        return new XamDoughnutChart();
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrDoughnutChart.prototype.onImplementationCreated = function () {
    };
    IgrDoughnutChart.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = tslib_1.__values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    IgrDoughnutChart.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = tslib_1.__values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return true;
    };
    IgrDoughnutChart.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "allowSliceSelection", {
        /**
         * Gets or sets whether the slices can be selected.
        */
        get: function () {
            return this.i.aw;
        },
        set: function (v) {
            this.i.aw = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "isSurfaceInteractionDisabled", {
        /**
         * Gets or sets whether all surface interactions with the plot area should be disabled.
        */
        get: function () {
            return this.i.ax;
        },
        set: function (v) {
            this.i.ax = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "allowSliceExplosion", {
        /**
         * Gets or sets whether the slices can be exploded.
        */
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "innerExtent", {
        /**
         * Gets or sets the inner extent of the doughnut chart. It is percent from the outer ring's radius.
        */
        get: function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "selectedSliceFill", {
        /**
         * Gets or sets the fill brush.
        */
        get: function () {
            return this.i.ce ? this.i.ce.fill : null;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.ce.fill = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "selectedSliceStroke", {
        /**
         * Gets or sets the stroke brush.
        */
        get: function () {
            return this.i.ce ? this.i.ce.stroke : null;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.ce.stroke = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "selectedSliceStrokeThickness", {
        /**
         * Gets or sets the stroke thickness.
        */
        get: function () {
            return this.i.ce ? this.i.ce.strokeThickness : NaN;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.ce.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "selectedSliceOpacity", {
        /**
         * Gets or sets the opacity.
        */
        get: function () {
            return this.i.ce ? this.i.ce.opacity : NaN;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.ce.opacity = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrDoughnutChart.prototype.ensureSelectedStyle = function () {
        if (this.i.ce) {
            return;
        }
        this.i.ce = new Style();
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.a4;
        },
        set: function (v) {
            this.i.a4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "actualPixelScalingRatio", {
        /**
         * Resolved pixel scaling ratio. Unless explicitly overridden by the IgxDoughnutChart.PixelScalingRatioComponent property,
         * this one returns the default ratio enforced by device. High resolution devices will initialize this property
         * to a higher value.
        */
        get: function () {
            return this.i.a1;
        },
        set: function (v) {
            this.i.a1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Used to notify the control that the control is no longer needed and can release any resources.
    
    */
    IgrDoughnutChart.prototype.destroy = function () {
        this.i.destroy();
    };
    /**
     * Called by the UI framework to provide a UI container for rendering this control.
    
    * @param container  * The UI container element.
    */
    IgrDoughnutChart.prototype.provideContainer = function (container) {
        this.i.provideContainer(container);
    };
    /**
     * Called when the control has been resized.
    
    */
    IgrDoughnutChart.prototype.notifyResized = function () {
        this.i.notifyResized();
    };
    /**
     * Gets the ID of the UI container.
    
    */
    IgrDoughnutChart.prototype.getContainerID = function () {
        var iv = this.i.bd();
        return (iv);
    };
    /**
     * Gets the center coordinates of the doughnut chart's center presenter.
    
    */
    IgrDoughnutChart.prototype.getCenterCoordinates = function () {
        var iv = this.i.cd();
        return fromPoint(iv);
    };
    /**
     * Gets the hole radius of the doughnut chart's center presenter.
    
    */
    IgrDoughnutChart.prototype.getHoleRadius = function () {
        var iv = this.i.a2();
        return (iv);
    };
    /**
     * Use to force the doughnut chart to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the doughnut chart needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the doughnut chart.
    
    */
    IgrDoughnutChart.prototype.flush = function () {
        this.i.bk();
    };
    /**
     * Returns the chart visuals expressed as a serialized string.
    
    */
    IgrDoughnutChart.prototype.exportSerializedVisualData = function () {
        var iv = this.i.bc();
        return (iv);
    };
    IgrDoughnutChart.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.bm(source_, index, newItem);
    };
    IgrDoughnutChart.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.bp(source_, index, oldItem, newItem);
    };
    /**
     * Used to manually notify the chart that the data source has reset or cleared its items.
    
    */
    IgrDoughnutChart.prototype.notifyClearItems = function (source_) {
        this.i.bl(source_);
    };
    IgrDoughnutChart.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.bn(source_, index, oldItem);
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "sliceClick", {
        /**
         * Raised when the slice is clicked.
        */
        get: function () {
            return this._sliceClick;
        },
        set: function (ev) {
            var _this = this;
            if (this._sliceClick !== null) {
                this.i.sliceClick = delegateRemove(this.i.sliceClick, this._sliceClick_wrapped);
                this._sliceClick_wrapped = null;
                this._sliceClick = null;
            }
            this._sliceClick = ev;
            this._sliceClick_wrapped = function (o, e) {
                var outerArgs = new SliceClickEventArgs();
                outerArgs._provideImplementation(e);
                _this._sliceClick(_this, outerArgs);
            };
            this.i.sliceClick = delegateCombine(this.i.sliceClick, this._sliceClick_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "holeDimensionsChanged", {
        /**
         * Raised when the dimensions (center point or radius) of the doughnut hole change.
        */
        get: function () {
            return this._holeDimensionsChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._holeDimensionsChanged !== null) {
                this.i.holeDimensionsChanged = delegateRemove(this.i.holeDimensionsChanged, this._holeDimensionsChanged_wrapped);
                this._holeDimensionsChanged_wrapped = null;
                this._holeDimensionsChanged = null;
            }
            this._holeDimensionsChanged = ev;
            this._holeDimensionsChanged_wrapped = function (o, e) {
                var outerArgs = new HoleDimensionsChangedEventArgs();
                outerArgs._provideImplementation(e);
                _this._holeDimensionsChanged(_this, outerArgs);
            };
            this.i.holeDimensionsChanged = delegateCombine(this.i.holeDimensionsChanged, this._holeDimensionsChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrDoughnutChart;
}(React.Component));
export { IgrDoughnutChart };
