import * as tslib_1 from "tslib";
import { IgrLegendBase } from "./igr-legend-base";
import { FinancialLegend } from "./FinancialLegend";
/**
 * Represents a legend that displays information about each series, most often used in financial charting.
*/
var IgrFinancialLegend = /** @class */ (function (_super) {
    tslib_1.__extends(IgrFinancialLegend, _super);
    function IgrFinancialLegend(props) {
        return _super.call(this, props) || this;
    }
    IgrFinancialLegend.prototype.createImplementation = function () {
        return new FinancialLegend();
    };
    Object.defineProperty(IgrFinancialLegend.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialLegend.prototype, "isFinancial", {
        /**
         * Gets if the legend is a financial legend.
        */
        get: function () {
            return this.i.isFinancial;
        },
        enumerable: true,
        configurable: true
    });
    return IgrFinancialLegend;
}(IgrLegendBase));
export { IgrFinancialLegend };
